#include <stddef.h>
#include <stdio.h>
#include "ttc_basic.h" 

/* Heap is 0 */
#define HEAPSIZE	0x000

signed char *sbrk( size_t size );

union HEAP_TYPE
{
	signed long dummy;
#if HEAPSIZE == 0
    signed char heap[1]; // array of size 0 not allowed by ISO C99
#else
    signed char heap[HEAPSIZE];
#endif
};

static union HEAP_TYPE	heap_area;

/* End address allocated by sbrk */
static signed char		*brk=( signed char * ) &heap_area;
signed char *sbrk( size_t size ) {
	signed char *p;
  Assert( HEAPSIZE != 0, ec_Malloc); // Will fail
	
	if( brk + size > heap_area.heap + HEAPSIZE )
	{
		p=( signed char * ) - 1;
	}
	else
	{
		p=brk;
		brk += size;
	}

	return p;
}

signed char *_sbrk( size_t size )                          { return sbrk( size ); }
       pid_t _getpid(void)                                 { return 1; }
        void _exit(int Status)                             { Assert(0,0); while (1) Status=Status; }
         int _kill (int pid, int sig)                      { Assert(0,0); pid=pid; sig= sig; return -1; }
     ssize_t _write(int fd, const void *buf, size_t count) { Assert(0,0);fd=fd; buf=buf; count=count; return count; }
         int _close(int fd)                                { Assert(0,0);fd=fd; return -1; }
         int _fstat(int fd, void *buf)                     { fd=fd; buf=buf; return 0; }
         int _isatty(int fd)                               { Assert(0,0);fd=fd; return 0; }
       off_t _lseek(int fd, off_t offset, int whence)      { Assert(0,0);fd=fd; offset=offset; whence=whence; return 0; }
     ssize_t _read(int fd, void *buf, size_t count)        { Assert(0,0);fd=fd; buf=buf; count=count; return 0; }
