#ifndef TTC_INPUT_TYPES_H
#define TTC_INPUT_TYPES_H

#include "ttc_basic.h"

typedef enum {
    gss_Default,
    gss_Rectangle,
    gss_Rounded
} tit_InputAreaShape_e;

typedef enum {
    me_MouseDown,
    me_MouseUp,
    me_MouseMove,
    me_MoveIn,
    me_MoveOut,
    me_noEvent

} tit_MouseEvent_e;

typedef struct {
    unsigned EventOnMouseDown:1;
    unsigned EventOnMouseUp:1;
    unsigned EventOnMouseIn:1;
    unsigned EventOnMouseContinous:1;
    unsigned EventOnMouseOut:1;
    unsigned Reserved:1;
    unsigned Reserved1:1;
    unsigned Reserved2:1;
}__attribute__((__packed__)) Events_t;

typedef struct tit_InputArea_s {
    u16_t Left;   //left end of the botton
    u16_t Top;    //top of the botton
    u16_t Right;  //right end of the botton
    u16_t Bottom; //buttom of the button
    u16_t X;      //activ X position
    u16_t Y;      //activ Y position
    tit_MouseEvent_e Event; //gives information about the events that is necessary for executing the handler
    tit_MouseEvent_e CurrentEvent;
    struct tit_InputArea_s* Next; //pointer on the next InputArea handler
    void  (*inputAreaHandler)(struct tit_InputArea_s* InputArea, u16_t X, u16_t Y); //pointer on the next touch handler
} tit_InputArea_t;

typedef struct tit_ButtonData_s {
    tit_InputArea_t Area; //Area of the Button
    void (*TouchHandler)(void* Argument); //pointer on the handler function
    void* Argument; //argument of the handler funtion
} tit_ButtonData_t;

typedef struct ScrollData_s {
    tit_InputArea_t Area; //Area of the Button
    u16_t oldX;      //previous X position
    u16_t oldY;      //previous Y position
} tit_ScrollData_t;

typedef struct
{
        u16_t X0;         //value of the x-position after the refinement
        u16_t Y0;         //value of the y-position after the refinement
        u16_t X;          //value of the x-position
        u16_t Y;          //value of the y-position
        int  Key_Sta;    //status of the key on the screen (Up, Down)
        u8_t ChipVersion; //
        float xfac;     //adjusting faktor of the x-value
        float yfac;     //adjusting faktor of the y-value
        short xoff;     //save the offset of the x-axis
        short yoff;     //save the offset of the y-axis
} tit_Pen_Holder_t; // ToDo: name?


#endif // TTC_INPUT_TYPES_H
