/*{ ttc_interrupt::.c ************************************************
 
                      The ToolChain
                      
   Device independent support for 
   Universal Synchronous Asynchronous Receiver and Transmitters (INTERRUPTs)
   
   written by Gregor Rebel 2012
   
 
}*/

#include "ttc_interrupt.h"

//{ Global variables *****************************************************

//}Global variables
//{ Function definitions *************************************************

ttc_interrupt_errorcode_e ttc_interrupt_init(ttc_interrupt_type_e Type, u8_t PhysicalIndex, void (*ISR)(u8_t, void*), void* Argument, void (**OldISR)(physical_index_t, void*), void** OldArgument) {

#ifdef TARGET_ARCHITECTURE_STM32
    return stm32_interrupt_init(Type, PhysicalIndex, ISR, Argument, OldISR, OldArgument);
#endif

    return ec_NotImplemented;
}
ttc_interrupt_errorcode_e ttc_interrupt_deinit(ttc_interrupt_type_e Type, u8_t PhysicalIndex) {
    return ttc_interrupt_init(Type, PhysicalIndex, NULL, NULL, NULL, NULL);
}
void ttc_interrupt_enable(ttc_interrupt_type_e Type, u8_t PhysicalIndex, BOOL EnableIRQ) {

#ifdef TARGET_ARCHITECTURE_STM32
    stm32_interrupt_enable(Type, PhysicalIndex, EnableIRQ);
#endif
}

//} Function definitions
