#ifndef TTC_RANDOM_H
#define TTC_RANDOM_H

/*{ stm32_random.h ***********************************************
 
 * Written by Gregor Rebel 2010-2012
 *
 * Basic datatypes, enums and functions
 * 
}*/
//{ Defines/ TypeDefs ****************************************************

// To be defined by architecture driver
// RAND_MAX
//     E.g.: #define RAND_MAX  (u32_t) -1

//} Defines

//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_spi_types.h"

#ifdef TARGET_ARCHITECTURE_STM32
  #include "stm32_random.h"
#endif

//} Includes

//{ Function prototypes **************************************************

/* returns random number 0..RAND_MAX
 * @return random number 0..RAND_MAX
 */
u32_t ttc_rand(void);

/* initializes pseudo random number generator with given value analog to srand()
 * @param Seed  will be used as new starting point
 */
void ttc_srand(u32_t Seed);

//}Function prototypes
#endif
