/*{ ttc_template.c *******************************************************

   I'M A TEMPLATE PLEASE CHANGE ME!

   Implementation of high-level driver.

}*/
//{ Defines/ TypDefs *****************************************************
//} Defines

#include "ttc_template.h"

//{ Global Variables *****************************************************

#if TTC_TEMPLATES_AMOUNT == 0
  #error No devices defined, check your makefile!
#endif

// for each initialized device, a pointer to its generic and architecture definitions is stored
ttc_array_define(ttc_template_generic_t*, ttc_templates, TTC_TEMPLATES_AMOUNT);

//} Global Variables
//{ Function definitions *************************************************

u8_t ttc_template_get_max_index() {
    return TTC_TEMPLATES_AMOUNT;
}
ttc_template_generic_t* ttc_template_get_configuration(u8_t LogicalIndex) {
    ttc_template_generic_t* Config = A(ttc_GFXs, LogicalIndex-1); // will assert if outside array bounds

    if (!Config) {
        Config = A(ttc_GFXs, LogicalIndex-1) = ttc_memory_alloc_zeroed(sizeof(ttc_gfx_generic_t));
        ttc_template_reset(LogicalIndex);
    }

    return Config;
}
void ttc_template_init(u8_t LogicalIndex) {
    ttc_template_generic_t* Config = ttc_template_get_configuration(LogicalIndex);

    switch (Config->Driver) {
#ifdef EXTENSION_400_Invalid
    case ttc_template_Invalid: Invalid_init(Config); break;
#endif
    default: break;
    }
}
void ttc_template_reset(u8_t LogicalIndex) {
    ttc_template_generic_t* Config = ttc_template_get_configuration(LogicalIndex);
    ttc_memory_set( Config, 0, sizeof(ttc_template_generic_t) );

    // load generic default values
    Config->LogicalIndex = LogicalIndex;

    switch (LogicalIndex)   { // load settings from makefile
#ifdef TTC_TEMPLATE1_DRIVER
    case 1: {
        Config->Driver = TTC_TEMPLATE1_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE2_DRIVER
    case 2: {
        Config->Driver = TTC_TEMPLATE2_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE3_DRIVER
    case 3: {
        Config->Driver = TTC_TEMPLATE3_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE4_DRIVER
    case 4: {
        Config->Driver = TTC_TEMPLATE4_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE5_DRIVER
    case 5: {
        Config->Driver = TTC_TEMPLATE5_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE6_DRIVER
    case 6: {
        Config->Driver = TTC_TEMPLATE6_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE7_DRIVER
    case 7: {
        Config->Driver = TTC_TEMPLATE7_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE8_DRIVER
    case 8: {
        Config->Driver = TTC_TEMPLATE8_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif
#ifdef TTC_TEMPLATE9_DRIVER
    case 9: {
        Config->Driver = TTC_TEMPLATE9_DRIVER;

        // ToDo: load settings for first device from makefile-constants TTC_TEMPLATE1_*
        break;
    }
#endif

    }
    switch (Config->Driver) { // load rest of configuration from low-level driver
#ifdef EXTENSION_400_Invald                // ToDo: rename Invalid to match your driver
    case ttc_template_Invalid:             // ToDo: rename Invalid to match your driver
        Invalid_get_configuration(Config); // ToDo: rename Invalid to match your driver
        break;
#endif

    // add more drivers here...

    default: Assert_Halt_EC(ec_NotImplemented); break;
    }

    // check for missing low-level implementations that have to be provided by driver
}

// ToDo: additional functions go here...

//} Function definitions
