/*{ ttc_template.h ************************************************

   I'M A TEMPLATE PLEASE CHANGE ME!

   Structures, Enums and Defines being required by high-level driver and application.

}*/

#ifndef TTC_TEMPLATE_H
#define TTC_TEMPLATE_H

//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_memory.h"
#include "ttc_template_types.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

//} Defines
//{ Structures/ Enums ****************************************************

// Structures and Enums required by High-Level driver only go here...

//} Structures/ Enums
//{ Function prototypes **************************************************

/** returns amount of devices available in current configuration
 *
 * @return amount of available devices
 */
u8_t ttc_template_get_max_index();

/** returns configuration of indexed device (asserts if no valid configuration was found)
 *
 * @param LogicalIndex    index of device to init (1..ttc_usart_get_max_LogicalIndex())
 * @return                configuration of indexed device
 */
ttc_template_generic_t* ttc_template_get_configuration(u8_t LogicalIndex);

/** initialize indexed device for use
 *
 * @param LogicalIndex    device index of device to init (1..ttc_usart_get_max_LogicalIndex())
 */
void ttc_template_init(u8_t LogicalIndex);

// additional prototypes go here...

//} Function prototypes
//{ private Function prototypes ******************************************

/** 
 *
 * Note: This function is marked private and should be called from outside!
 *
 * @param 
 * @return
 */
void _ttc_template_();


//}private functions
//{ Macros ***************************************************************

//}Macros

#endif //TTC_TEMPLATE_H
