/*{ ttc_template_types.h ************************************************

   I'M A TEMPLATE PLEASE CHANGE ME!
   
   Structures, Enums and Defines being required by both, high- and low-level driver.
   
}*/

#ifndef TTC_TEMPLATE_TYPES_H
#define TTC_TEMPLATE_TYPES_H

#include "ttc_basic.h"

//{ Defines ***************************************************


//} Defines
//{ Static Configuration **************************************

// TTC_TEMPLATEn has to be defined as constant by makefile.100_board_*
#ifdef TTC_TEMPLATE5
  #ifndef TTC_TEMPLATE4
    #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE4 - all lower TTC_TEMPLATEn must be defined!
  #endif
  #ifndef TTC_TEMPLATE3
    #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE3 - all lower TTC_TEMPLATEn must be defined!
  #endif
  #ifndef TTC_TEMPLATE2
    #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE2 - all lower TTC_TEMPLATEn must be defined!
  #endif
  #ifndef TTC_TEMPLATE1
    #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE1 - all lower TTC_TEMPLATEn must be defined!
  #endif

  #define TTC_TEMPLATES_AMOUNT 5
#else
  #ifdef TTC_TEMPLATE4
    #define TTC_TEMPLATES_AMOUNT 4

    #ifndef TTC_TEMPLATE3
      #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE3 - all lower TTC_TEMPLATEn must be defined!
    #endif
    #ifndef TTC_TEMPLATE2
      #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE2 - all lower TTC_TEMPLATEn must be defined!
    #endif
    #ifndef TTC_TEMPLATE1
      #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE1 - all lower TTC_TEMPLATEn must be defined!
    #endif
  #else
    #ifdef TTC_TEMPLATE3

      #ifndef TTC_TEMPLATE2
        #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE2 - all lower TTC_TEMPLATEn must be defined!
      #endif
      #ifndef TTC_TEMPLATE1
        #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE1 - all lower TTC_TEMPLATEn must be defined!
      #endif

      #define TTC_TEMPLATES_AMOUNT 3
    #else
      #ifdef TTC_TEMPLATE2

        #ifndef TTC_TEMPLATE1
          #error TTC_TEMPLATE5 is defined, but not TTC_TEMPLATE1 - all lower TTC_TEMPLATEn must be defined!
        #endif

        #define TTC_TEMPLATES_AMOUNT 2
      #else
        #ifdef TTC_TEMPLATE1
          #define TTC_TEMPLATES_AMOUNT 1
        #else
          #define TTC_TEMPLATES_AMOUNT 0
        #endif
      #endif
    #endif
  #endif
#endif

#ifndef TTC_ASSERT_GFX    // any previous definition set (Makefile)?
#define TTC_ASSERT_GFX 1  // string asserts are enabled by default
#endif
#if (TTC_ASSERT_GFX == 1)  // use Assert()s in GFX code (somewhat slower but alot easier to debug)
  #define Assert_GFX(Condition, ErrorCode) Assert(Condition, ErrorCode)
#else  // us no Assert()s in GFX code (somewhat smaller + faster, but crashes are hard to debug)
  #define Assert_GFX(Condition, ErrorCode)
#endif

#ifndef TTC_TEMPLATE_SINGLE_THREADED // == 1: functions can use static variables to speed up function calls + reduce stack usage
#define TTC_TEMPLATE_SINGLE_THREADED 1
#endif
#if (TTC_TEMPLATE_SINGLE_THREADED == 1)
  #define GFX_STATIC static
#else
  #define GFX_STATIC
#endif

#define ABS(a) ((a)<0 ? -(a) : (a))

// Color defines *********************************************

#define GFX_COLOR24_BLACK   0x000000
#define GFX_COLOR24_SILVER  0xC0C0C0
#define GFX_COLOR24_GRAY    0x808080
#define GFX_COLOR24_WHITE   0xFFFFFF
#define GFX_COLOR24_MAROON  0x800000
#define GFX_COLOR24_RED     0xFF0000
#define GFX_COLOR24_PURPLE  0x800080
#define GFX_COLOR24_FUCHSIA 0xFF00FF
#define GFX_COLOR24_GREEN   0x008000
#define GFX_COLOR24_LIME    0x00FF00
#define GFX_COLOR24_OLIVE   0x808000
#define GFX_COLOR24_YELLOW  0xFFFF00
#define GFX_COLOR24_NAVY    0x000080
#define GFX_COLOR24_BLUE    0x0000FF
#define GFX_COLOR24_TEAL    0x008080
#define GFX_COLOR24_AQUA    0x00FFFF

//}Static Configuration
//{ Structures ************************************************

typedef enum {
    ttc_template_None,
    
    // ToDo: additional driver types go here...
    
    ttc_template_Invalid
} ttc_template_driver_e;
typedef struct ttc_template_generic_s { // architecture independent configuration data

    // Note: Write-access to this structure is only allowed before first ttc_template_init() call!
    //       After initialization, only read accesses are allowed for high-level code.

    u8_t LogicalIndex;               // automatically set: logical index of display to use (1 = TTC_TEMPLATE1, ...)
    ttc_template_driver_e Driver;    // type of low-level driver serving this device
    
    union  {
        u32_t All;
        struct {
            
          // ToDo: additional high-level flags go here..
            
            unsigned Reserved1        : 32; // pad to 32 bits
        } Bits;
    } Flags;

    // ToDo: additional high-level attributes go here
    
} __attribute__((__packed__)) ttc_template_generic_t;

//}Structures

#endif // TTC_TEMPLATE_TYPES_H
