#!/bin/bash
#
# Create links to external tools/ sources provided by ToolChain_STM32
# into current directory
#
# Usage:
# cd to yur source-code directory
# isssue createLinks.sh 
#
# Example:
# cd ~/Source/Test123
# ./createLinks.sh
#

Source="$HOME/Source"

echo "$0: regenerating links.."
rm 2>/dev/null _;                     ln -sv $Source/ToolChain_STM32/ToolChain/scripts  _
for Script in makefile clean.sh; do
  if [ ! -e $Script ]; then
    rm 2>/dev/null $Script
    ln -sv _/$Script .
  fi
done
rm 2>/dev/null common;    ln -sv $Source/ToolChain_STM32/CommonLibraries/   common
#X rm 2>/dev/null examples;  ln -sv $Source/ToolChain_STM32/Examples/          examples

Version=`cat _/Version`

# create links to third party modules
source ./_/createLinks.sh

echo "ToolChain_STM32 v$Version"
