/*{ example_gfx_benchmark.h ************************************************
 
  Benchmark code for ttc_gfx.c/.h for current architecture and display.
  
  written by Gregor Rebel 2012
 
}*/

//{ Includes *************************************************************

// Basic set of helper functions
#include "ttc_basic.h"
#include "ttc_task.h"
#include "ttc_string.h"
#include "ttc_gfx.h"
#include "ttc_usart.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

#ifndef EXTENSION_500_ttc_gfx
  #error Missing EXTENSION_500_ttc_gfx !
#endif

//} Defines
//{ Structures/ Enums ****************************************************


//} Structures/ Enums
//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

/** basic hardware intialization
  */
void gfx_benchmark_init();

/** main entry: initializes hardware + spawns all threads
  * returns immediately
  */
void example_gfx_benchmark_start();

/** main task
  */
void task_gfx_benchmark(void *pvParameters);

/** deliver defined series of random data */
u16_t getNextRandom();
void printResults();
void resetRandom();

/** individual benchmarks
 *
 * @param Count   amount of iterations
 * @return        elapsed time of individual benchmark (us)
 */
Base_t benchmark_Circle(u8_t Count);
Base_t benchmark_Clear(u8_t Count);
Base_t benchmark_Line(u8_t Count);
Base_t benchmark_Line_ortho(u8_t Count);
Base_t benchmark_Rect(u8_t Count);
Base_t benchmark_RectFill(u8_t Count);
Base_t benchmark_SetPixel(u8_t Count);
Base_t benchmark_Text(u8_t Count);

//} Function prototypes
