#!/bin/bash

Binary=`which qtcreator`
if [ "$Binary" == "" ]; then
  Binary=`find /opt/ -name qtcreator 2>/dev/null | grep bin`
fi
if [ "$Binary" == "" ]; then
  Binary=`find $HOME/Source/qtcreator/bin/ -name qtcreator 2>/dev/null`
fi
if [ "$Binary" == "" ]; then
  echo ""
  echo "$0 - ERROR: Cannot find executable qtcreator somewhere in $PATH"
  echo "$0 - Make sure that QtCreator is installed (download from http://qt-project.org/downloads)"
  echo ""
  exit 10  
fi

echo "$0 - Using QtCreator binary $Binary .."
find QtCreator/ -name "*.creator" -exec $Binary {} \; &
