#!/bin/bash

killall -9 openocd # make sure that no other one is running

CMD="openocd $@"
echo "> $CMD" | tee openocd.log
echo ""       | tee openocd.log
$CMD 2>&1     | tee --append openocd.log
Error=`grep -i "Error: " openocd.log`
Error2=`grep 'Unable to open FTDI Device' openocd.log`
IsError="${Error}${Error2}"
if [ "$IsError" != "" ]; then
  source configs/interface.cfg
  #echo "> $CMD"
  if [ "$Error" != "" ]; then
    echo "ERROR: $Error"
  fi
  if [ "$Error2" != "" ]; then
    echo "ERROR: $Error2"
  fi
  echo ""
  cat openocd.log
  echo ""
  if [ "$Interface" != "" ]; then
    echo "ERROR: Cannot connect via interface $Interface!";
  else
    echo "ERROR: No Interface defined. Check file configs/interface.cfg for available interfaces!"
    return 6
  fi
  cat <<END_OF_MSG
  
       Possible Solutions:
       - Check cabling PC <-> Programmer <-> Board <-> uC
       - Make sure that programmer has been recognized as USB device:
         lsusb
       - activate interface according to your JTAG-programmer:
         nano `pwd`/configs/interface.cfg
END_OF_MSG
  return 5
fi
return 0